Attribute VB_Name = "modPraceSRodokmeny"
Option Explicit
Option Compare Text

'Vlastn uivatelsk typ, osoba s vlastnostmi v rodokmenu
Public Type Osoba
    ID As String * 10
    Jmeno As String * 32
    Prijmeni As String * 32
    Pohlavi As String * 1
    Narozeni As String * 4
    Umrti As String * 4
    Matka As String * 10
    Otec As String * 10
End Type

Public VsechnyOsoby() As Osoba 'Hlavn promnn se vemi lidmy ze souboru

Dim AktualniOsobaPole As Long 'Pomocn promnn

'Procedura, kter ulo data do XML
Public Sub UlozitDoSouboru(Soubor As String)
    Dim Data As String, cykl As Long 'Pomocn promnn
    
    Data = "<rodokmen>" 'soubor mus zanat tagem <rodokmen>
    
    'vype do souboru vechny poloky vech osob
    For cykl = 1 To UBound(VsechnyOsoby)
        Data = Data & "<osoba>"
        Data = Data & "<id>" & Trim(VsechnyOsoby(cykl).ID) & "</id>"
        Data = Data & "<jmeno>" & Trim(VsechnyOsoby(cykl).Jmeno) & "</jmeno>"
        Data = Data & "<prijmeni>" & Trim(VsechnyOsoby(cykl).Prijmeni) & "</prijmeni>"
        Data = Data & "<pohlavi>" & Trim(VsechnyOsoby(cykl).Pohlavi) & "</pohlavi>"
        Data = Data & "<narozeni>" & Trim(VsechnyOsoby(cykl).Narozeni) & "</narozeni>"
        Data = Data & "<umrti>" & Trim(VsechnyOsoby(cykl).Umrti) & "</umrti>"
        Data = Data & "<matka>" & Trim(VsechnyOsoby(cykl).Matka) & "</matka>"
        Data = Data & "<otec>" & Trim(VsechnyOsoby(cykl).Otec) & "</otec>"
        Data = Data & "</osoba>"
    Next cykl
    
    Data = Data & "</rodokmen>" 'soubor mus konit tagem </rodokmen>
    
    'Ulo do souboru
    Open Soubor For Output As #1
        Print #1, Data
    Close #1
End Sub

'Procedura, kter nate data ze souboru
Public Sub NactiZeSouboru(Soubor As String)
    Dim Radek As String, CelySoubor As String
    
    'Nate po dcch soubor
    Open Soubor For Input As #1
        Do
            If EOF(1) Then Exit Do
            Line Input #1, Radek
            CelySoubor = CelySoubor & Radek 'pid dek
        Loop
    Close #1
    
    'Pole data na zpracovn
    ZpracujData CelySoubor
End Sub

'Procedura na zpracovn dat
Public Sub ZpracujData(Data As String)
    Dim Osoby(1 To 999999) As String, AktualniOsoba As Long
    Dim ZapniZapisDoOsoby As Boolean
    Dim Cyklus As Long
    
    'nen dn aktual. osoba
    AktualniOsoba = 0
    
    'vymae tag <rodokmen> a </rodokmen>
    Data = Replace(Data, "<rodokmen>", "")
    Data = Replace(Data, "</rodokmen>", "")
    
    'vyzna si kde kon a zan osoba
    Data = Replace(Data, "<osoba>", "##z_o")
    Data = Replace(Data, "</osoba>", "##k_o")
    
    'projde znak po znaku soubor a zape si data osob
    For Cyklus = 1 To Len(Data)
        If Mid(Data, Cyklus, 5) = "##z_o" Then
            AktualniOsoba = AktualniOsoba + 1
            ZapniZapisDoOsoby = True
            Cyklus = Cyklus + 4
            GoTo Konec
        End If
        If Mid(Data, Cyklus, 5) = "##k_o" Then
            ZapniZapisDoOsoby = False
            Cyklus = Cyklus + 4
            GoTo Konec
        End If
        If ZapniZapisDoOsoby = True Then
            Osoby(AktualniOsoba) = Osoby(AktualniOsoba) & Mid(Data, Cyklus, 1)
        End If
Konec:
    Next Cyklus
    
    ReDim VsechnyOsoby(1 To AktualniOsoba)
    
    AktualniOsobaPole = 0
    For Cyklus = 1 To AktualniOsoba
        'pole osoby k uloen do promnn
        ZpracujOsobu Osoby(Cyklus)
    Next
End Sub

'Procedura na zpracovn osob
Private Sub ZpracujOsobu(Osoba As String)
    Dim OsobaZpracovana As Osoba
    
    On Error Resume Next 'pi chyb pokraovat
    
    AktualniOsobaPole = AktualniOsobaPole + 1
    
    'vyhled tagy a nate si je do promnn
    OsobaZpracovana.ID = Trim(Mid(Osoba, InStr(Osoba, "<id>") + Len("<id>"), InStr(Osoba, "</id>") - InStr(Osoba, "<id>") - Len("<id>")))
    If Not Osoba Like "<jmeno>" Or Osoba Like "<jmeno/>" Then OsobaZpracovana.Jmeno = Trim(Mid(Osoba, InStr(Osoba, "<jmeno>") + Len("<jmeno>"), InStr(Osoba, "</jmeno>") - InStr(Osoba, "<jmeno>") - Len("<jmeno>")))
    If Not Osoba Like "<prijmeni>" Or Osoba Like "<prijmeni/>" Then OsobaZpracovana.Prijmeni = Trim(Mid(Osoba, InStr(Osoba, "<prijmeni>") + Len("<prijmeni>"), InStr(Osoba, "</prijmeni>") - InStr(Osoba, "<prijmeni>") - Len("<prijmeni>")))
    If Not Osoba Like "<pohlavi>" Or Osoba Like "<pohlavi/>" Then OsobaZpracovana.Pohlavi = Trim(Mid(Osoba, InStr(Osoba, "<pohlavi>") + Len("<pohlavi>"), InStr(Osoba, "</pohlavi>") - InStr(Osoba, "<pohlavi>") - Len("<pohlavi>")))
    If Not Osoba Like "<narozeni>" Or Osoba Like "<narozeni/>" Then OsobaZpracovana.Narozeni = Trim(Mid(Osoba, InStr(Osoba, "<narozeni>") + Len("<narozeni>"), InStr(Osoba, "</narozeni>") - InStr(Osoba, "<narozeni>") - Len("<narozeni>")))
    If Not Osoba Like "<umrti>" Or Osoba Like "<umrti/>" Then OsobaZpracovana.Umrti = Trim(Mid(Osoba, InStr(Osoba, "<umrti>") + Len("<umrti>"), InStr(Osoba, "</umrti>") - InStr(Osoba, "<umrti>") - Len("<umrti>")))
    If Not Osoba Like "<matka>" Or Osoba Like "<matka/>" Then OsobaZpracovana.Matka = Trim(Mid(Osoba, InStr(Osoba, "<matka>") + Len("<matka>"), InStr(Osoba, "</matka>") - InStr(Osoba, "<matka>") - Len("<matka>")))
    If Not Osoba Like "<otec>" Or Osoba Like "<otec/>" Then OsobaZpracovana.Otec = Trim(Mid(Osoba, InStr(Osoba, "<otec>") + Len("<otec>"), InStr(Osoba, "</otec>") - InStr(Osoba, "<otec>") - Len("<otec>")))
    OsobaZpracovana.ID = Trim(OsobaZpracovana.ID)
    OsobaZpracovana.Jmeno = Trim(OsobaZpracovana.Jmeno)
    OsobaZpracovana.Matka = Trim(OsobaZpracovana.Matka)
    OsobaZpracovana.Narozeni = Trim(OsobaZpracovana.Narozeni)
    OsobaZpracovana.Otec = Trim(OsobaZpracovana.Otec)
    OsobaZpracovana.Pohlavi = Trim(OsobaZpracovana.Pohlavi)
    OsobaZpracovana.Prijmeni = Trim(OsobaZpracovana.Prijmeni)
    OsobaZpracovana.Umrti = Trim(OsobaZpracovana.Umrti)
    
    VsechnyOsoby(AktualniOsobaPole) = OsobaZpracovana
End Sub

'Procedura pro zobrazen seznamu
Public Sub ZobrazitSeznam(Seznam As RichTextBox)
    Dim Cyklus As Long, Cyklus1 As Long
    Dim Jmeno As String, Prijmeni As String, Pohlavi As String, Narozeni As String, Umrti As String, Matka As String, Otec As String, ID As String
    
    'zept se jestli chcete zobrazit vechny daje
    If MsgBox("Chcete zobrazit pln seznam ?", vbYesNo, "Rodokmeny") = vbYes Then
        Seznam.Text = "Rodokmeny - seznam lid" & vbCrLf & "____________________________________________________________________________________" & vbCrLf
        'zape lidi do textboxu
    
        For Cyklus = 1 To UBound(VsechnyOsoby)
            Jmeno = Trim(VsechnyOsoby(Cyklus).Jmeno)
            If Jmeno = Chr(0) Then Jmeno = "nen"
            Prijmeni = Trim(VsechnyOsoby(Cyklus).Prijmeni)
            If Prijmeni = Chr(0) Then Prijmeni = "nen"
            Pohlavi = Trim(VsechnyOsoby(Cyklus).Pohlavi)
            If Pohlavi = Chr(0) Then Pohlavi = "nen"
            If Pohlavi Like "m" Then Pohlavi = "mu"
            If Pohlavi Like "z" Then Pohlavi = "ena"
            Narozeni = Trim(VsechnyOsoby(Cyklus).Narozeni)
            If Narozeni = Chr(0) Then Narozeni = "nen"
            Umrti = Trim(VsechnyOsoby(Cyklus).Umrti)
            If Umrti = Chr(0) Then Umrti = "nen"
            Matka = Trim(VsechnyOsoby(Cyklus).Matka)
            If Matka = Chr(0) Then Matka = "nen"
            If Not Matka = "nen" Then
                For Cyklus1 = 1 To UBound(VsechnyOsoby)
                    If Trim(VsechnyOsoby(Cyklus1).ID) Like Matka Then Matka = Trim(VsechnyOsoby(Cyklus1).Jmeno) & " " & Trim(VsechnyOsoby(Cyklus1).Prijmeni): Exit For
                Next Cyklus1
            End If
            Otec = Trim(VsechnyOsoby(Cyklus).Otec)
            If Otec = Chr(0) Then Otec = "nen"
            If Not Otec = "nen" Then
                For Cyklus1 = 1 To UBound(VsechnyOsoby)
                    If Trim(VsechnyOsoby(Cyklus1).ID) Like Otec Then Otec = Trim(VsechnyOsoby(Cyklus1).Jmeno) & " " & Trim(VsechnyOsoby(Cyklus1).Prijmeni): Exit For
                Next Cyklus1
            End If
            ID = Trim(VsechnyOsoby(Cyklus).ID)
            Seznam.Text = Seznam.Text & vbCrLf & "Jmno: " & Jmeno & ",   Pjmen: " & Prijmeni & ",   Pohlav: " & Pohlavi & ",   Datum nar.: " & Narozeni & ",   Datum umr.: " & Umrti & ",   Matka: " & Matka & ",   Otec: " & Otec & ",   ID: " & ID & vbCrLf
        Next Cyklus
    Else
        Seznam.Text = "Rodokmeny - seznam lid" & vbCrLf & "____________________________________________________________________________________" & vbCrLf
    
        For Cyklus = 1 To UBound(VsechnyOsoby)
            Jmeno = Trim(VsechnyOsoby(Cyklus).Jmeno)
            If Jmeno = Chr(0) Then Jmeno = "nen"
            Prijmeni = Trim(VsechnyOsoby(Cyklus).Prijmeni)
            If Prijmeni = Chr(0) Then Prijmeni = "nen"
            Pohlavi = Trim(VsechnyOsoby(Cyklus).Pohlavi)
            If Pohlavi = Chr(0) Then Pohlavi = "nen"
            If Pohlavi Like "m" Then Pohlavi = "mu"
            If Pohlavi Like "z" Then Pohlavi = "ena"
            ID = Trim(VsechnyOsoby(Cyklus).ID)
            Seznam.Text = Seznam.Text & vbCrLf & "Jmno: " & Jmeno & ",   Pjmen: " & Prijmeni & ",   Pohlav: " & Pohlavi & ",   ID: " & ID & vbCrLf
        Next Cyklus
    End If
End Sub
